/*******************************************************************
 *
 * File: play.c
 * 
 * Author: Tomasz Stachowiak
 *
 * Description: Play audio from a file in raw format
 *
 * Date: 07.18.96
 *
 *******************************************************************/


#include <stdio.h>
#include <signal.h>
#include <dmedia/audio.h>

#include "params.h"
#include "adpcm.h"


ALport speaker;
ALconfig conf;
FILE *file, *out;
char *buf;

void print_rate()
{
  long par[2];

  par[0] = AL_OUTPUT_RATE;
  par[1] = 8000;
  ALsetparams(AL_DEFAULT_DEVICE, par, 2);
  ALgetparams(AL_DEFAULT_DEVICE, par, 2);
  printf("Input rate: %d\n", par[1]);
}



main()
{
  struct adpcm_state state;
  char coded[BUF_SIZE/4];
  int i;

  print_rate();

  buf = malloc(BUF_SIZE);  
  file = fopen("micro.audio", "r");
  out = fopen("micro.out", "w");

  if ((conf = ALnewconfig()) == 0)
    fprintf (stderr, "Config allocation error\n");
  if (ALsetchannels(conf, MONO) < 0)
    fprintf (stderr, "Setting channel error\n");
  if (ALsetqueuesize(conf, QSIZE) < 0)
    fprintf (stderr, "Setting queue size error\n");
  if (ALsetwidth(conf, AL_SAMPLE_16) < 0)
    fprintf (stderr, "Setting sample width error\n");

  if ((speaker = ALopenport("speaker", "w", conf)) == 0)
    fprintf (stderr, "Port opening error");
 
  while(!feof(file))
    {
      fread(coded, BLOCK/2, 1, file);
      state.index = 0;
      state.valprev = 0;
      adpcm_decoder(coded, buf, BLOCK, &state);
      fwrite(buf, BLOCK*2, 1, out);
      ALwritesamps(speaker, buf, BLOCK);
    }

  free(buf);
  ALcloseport(speaker);
  fclose(file);
  fclose(out);
}














